"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
exports.__esModule = true;
var Koa = require("koa");
var Router = require("koa-router");
var cors = require("kcors");
var bodyParser = require("koa-bodyparser");
var parse = require('extended-json-js').parse;
exports["default"] = function (getCollection, nibbanaToken, apiSecret) {
    var router = new Router();
    router.use(bodyParser());
    router.use(cors());
    router.use(function (ctx, next) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    ctx.response.type = 'application/json;charset=UTF-8';
                    return [4 /*yield*/, next()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    router.post('/run-pipeline', function (ctx) { return __awaiter(_this, void 0, void 0, function () {
        var requestApiSecret, pipelineString, pipeline, collection, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log('Executing nibbana pipeline...');
                    requestApiSecret = ctx.request.headers['nibbana-api-secret'];
                    if (requestApiSecret !== apiSecret) {
                        ctx["throw"](403, 'Incorrect secret');
                    }
                    pipelineString = ctx.request.body.pipelineString;
                    if (!pipelineString) {
                        ctx["throw"](400, 'pipelineString is falsy');
                    }
                    pipeline = parse(pipelineString);
                    return [4 /*yield*/, getCollection()];
                case 1:
                    collection = _a.sent();
                    return [4 /*yield*/, collection.aggregate(pipeline).toArray()];
                case 2:
                    result = _a.sent();
                    ctx.body = result;
                    return [2 /*return*/];
            }
        });
    }); });
    router.post('/upload-entries', function (ctx) { return __awaiter(_this, void 0, void 0, function () {
        var requestNibbanaToken, collection, entriesString, entries, _i, entries_1, entry;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log('Saving nibbana entries...');
                    requestNibbanaToken = ctx.request.headers['nibbana-token'];
                    if (requestNibbanaToken !== nibbanaToken) {
                        ctx["throw"](403, 'Incorrect token');
                    }
                    return [4 /*yield*/, getCollection()];
                case 1:
                    collection = _a.sent();
                    entriesString = ctx.request.body.entriesString;
                    if (!entriesString) {
                        return [2 /*return*/];
                    }
                    entries = parse(entriesString);
                    _i = 0, entries_1 = entries;
                    _a.label = 2;
                case 2:
                    if (!(_i < entries_1.length)) return [3 /*break*/, 5];
                    entry = entries_1[_i];
                    return [4 /*yield*/, collection.update({ _id: entry._id }, entry, { upsert: true })];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4:
                    _i++;
                    return [3 /*break*/, 2];
                case 5: return [2 /*return*/];
            }
        });
    }); });
    var app = new Koa();
    app.use(cors());
    app.use(router.routes()).use(router.allowedMethods());
    return app;
};
